> This page is for Afterpay Partner API.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.afterpay.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.afterpay.com/_mcp/server.

# Approve Contract

POST https://agencyapi.afterpay.com/v1/rates-contract/{contractId}/review
Content-Type: application/json

Partners can set up their unique, volume-based buy-rate contract that precisely enforces their commercial agreement with Afterpay. This prevents any mis-billings from day one and has with a full audit trail.

Reference: https://developers.afterpay.com/afterpay-partner-api/api-reference/reference-partner-api/rates/review-contract

## Servers

- `https://agencyapi.afterpay.com` (Production, default)
- `https://agencyapi.sandbox.afterpay.com` (Sandbox)

## Request

### Path parameters

- `contractId` (string, required) — ID of the contract to approve

### Headers

- `Accept` (string, required, default: application/json) — Specifies media types that are acceptable for the response.

### Body (application/json)

This endpoint expects an object.

- `contractId` (string, required) — The unique ID for the contract between Afterpay and the partner.
- `userDetails` (User, required)
- `comment` (string, required) — Comment specific to the contract request.
- `status` (enum, required) — The de facto approval field that determines whether the contract request by Afterpay is approved or rejected by the partner.
  - Allowed values: `APPROVED`, `REJECTED`
- `countryCode` (string, required) — Country code in the two-letter ISO 3166-1 alpha-2 standard format, defining the consumer market for which the rates apply.
- `buyRates` (BuyRates, required)

## Response

### 200

Contract reviewed successfully

- `timestamp` (string, optional) — Datetime field indicating when the contract request was actioned, using the standard ISO 8601 format, returned in UTC Coordinated Universal Time).
- `error` (string, optional) — Shows any errors encountered on the response to the contract approval call.
- `message` (string, optional) — Any message that may be attached to the response.
- `contractDetails` (Contract, optional)

## Errors

### 400 Bad Request Error

Bad request, e.g., contract not in PENDING status

- `timestamp` (string, optional) — Timestamp of the response.
- `status` (integer, optional) — The HTTP status code.
- `error` (string, optional) — Name of the error that occurred.
- `message` (string, optional) — A human-readable message which provides more details about the error.
- `path` (string, optional) — The attempted endpoint.

### 401 Unauthorized Error

Unauthorized, e.g., HMAC verification failed

- `timestamp` (string, optional) — Timestamp of the response.
- `status` (integer, optional) — The HTTP status code.
- `error` (string, optional) — Name of the error that occurred.
- `message` (string, optional) — A human-readable message which provides more details about the error.
- `path` (string, optional) — The attempted endpoint.

### 404 Not Found Error

Contract not found

- `timestamp` (string, optional) — Timestamp of the response, indicating when the error occurred.
- `status` (integer, optional) — The HTTP status code, specifically indicating a 404 error in this case.
- `error` (string, optional) — A short description of the error, typically "Not Found" for a 404 response.
- `message` (string, optional) — A human-readable message providing more details about the error.
- `path` (string, optional) — The attempted endpoint path that resulted in the 404 error.

### 503 Service Unavailable Error

Service unavailable.

- `timestamp` (string, optional) — Timestamp of the response.
- `status` (integer, optional) — The HTTP status code.
- `error` (string, optional) — Name of the error that occurred.
- `message` (string, optional) — A human-readable message which provides more details about the error.
- `path` (string, optional) — The attempted endpoint.

## Types

### User

- `firstName` (string, required) — Given name of the user who is actioning Afterpay's contract request.
- `lastName` (string, required) — Surname of the user who is actioning Afterpay's contract request.
- `email` (string, required) — Email of the user.
- `adminIdentifier` (string, optional, nullable) — Optional identifier for the admin..

### BuyRates

- `defaultRates` (BaseRate, required)
- `tierDetails` (list of BuyRatesTierDetailsItems, required) — Volume-based tiers and rates object.

### Contract

- `contractId` (string, optional) — The unique ID for the contract between Afterpay and the partner.
- `effectiveFrom` (string, optional) — Effective date and time of when the contract applies, using the standard ISO 8601 format, returned in UTC Coordinated Universal Time).
- `status` (enum, optional) — Contract status
  - Allowed values: `APPROVED`, `REJECTED`, `PENDING`
- `countryCode` (string, optional) — Country code in the two-letter ISO 3166-1 alpha-2 standard format, defining the consumer market for which the contact applies.

### BaseRate

- `variableRatePercentage` (string, required) — Variable part of the buy-rate in percentage format e.g. 5.00 for 5%.
- `fixedRate` (string, required) — Fixed part of the buy-rate e.g. 0.30 for 30 cents.
- `fixedRateCurrencyCode` (string, required) — Currency of the fixed part of the buy-rate in the three-letter ISO 4217 currency code.
- `rateType` (enum, required) — Type of rate whether introductory for temporary promotional periods or ongoing for steady-state business.
  - Allowed values: `INTRODUCTORY`, `ONGOING`
- `durationInMonths` (integer, optional) — Number of months that the introductory rate will be applied.

### BuyRatesTierDetailsItems

- `tier` (integer, required) — Volume-based tier that was defined during commercial discussions.
- `minimumGmv` (string, required) — Lower bound of the tier.
- `maximumGmv` (string, required) — Higher bound of the tier.
- `GmvCurrencyCode` (string, required) — Currency of the GMV tier.
- `tieredRates` (list of BaseRate, required)

## Examples

**Request**

```json
{
  "contractId": "785389121238",
  "userDetails": {
    "firstName": "John",
    "lastName": "PSP",
    "email": "john.psp@psp.com"
  },
  "comment": "Approved by X on date Y for reason Z.",
  "status": "APPROVED",
  "countryCode": "US",
  "buyRates": {
    "defaultRates": {
      "variableRatePercentage": "5.00",
      "fixedRate": "0.30",
      "fixedRateCurrencyCode": "USD",
      "rateType": "ONGOING"
    },
    "tierDetails": [
      {
        "tier": 1,
        "minimumGmv": "0",
        "maximumGmv": "1000000",
        "GmvCurrencyCode": "USD",
        "tieredRates": [
          {
            "variableRatePercentage": "3.5",
            "fixedRate": "0.3",
            "fixedRateCurrencyCode": "USD",
            "rateType": "ONGOING"
          }
        ]
      }
    ]
  }
}
```

**Response**

```json
{
  "timestamp": "2023-08-17T21:41:47.341+00:00",
  "error": "string",
  "message": "Successfully reviewed agency contract",
  "contractDetails": {
    "contractId": "785389121238",
    "effectiveFrom": "2023-09-17T21:41:47.341+00:00",
    "status": "APPROVED",
    "countryCode": "US"
  }
}
```

**SDK Code**

```python
import requests

url = "https://agencyapi.afterpay.com/v1/rates-contract/123457838/review"

payload = {
    "contractId": "785389121238",
    "userDetails": {
        "firstName": "John",
        "lastName": "PSP",
        "email": "john.psp@psp.com"
    },
    "comment": "Approved by X on date Y for reason Z.",
    "status": "APPROVED",
    "countryCode": "US",
    "buyRates": {
        "defaultRates": {
            "variableRatePercentage": "5.00",
            "fixedRate": "0.30",
            "fixedRateCurrencyCode": "USD",
            "rateType": "ONGOING"
        },
        "tierDetails": [
            {
                "tier": 1,
                "minimumGmv": "0",
                "maximumGmv": "1000000",
                "GmvCurrencyCode": "USD",
                "tieredRates": [
                    {
                        "variableRatePercentage": "3.5",
                        "fixedRate": "0.3",
                        "fixedRateCurrencyCode": "USD",
                        "rateType": "ONGOING"
                    }
                ]
            }
        ]
    }
}
headers = {
    "Accept": "application/json",
    "User-Agent": "User-Agent",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://agencyapi.afterpay.com/v1/rates-contract/123457838/review';
const options = {
  method: 'POST',
  headers: {
    Accept: 'application/json',
    'User-Agent': 'User-Agent',
    'Content-Type': 'application/json'
  },
  body: '{"contractId":"785389121238","userDetails":{"firstName":"John","lastName":"PSP","email":"john.psp@psp.com"},"comment":"Approved by X on date Y for reason Z.","status":"APPROVED","countryCode":"US","buyRates":{"defaultRates":{"variableRatePercentage":"5.00","fixedRate":"0.30","fixedRateCurrencyCode":"USD","rateType":"ONGOING"},"tierDetails":[{"tier":1,"minimumGmv":"0","maximumGmv":"1000000","GmvCurrencyCode":"USD","tieredRates":[{"variableRatePercentage":"3.5","fixedRate":"0.3","fixedRateCurrencyCode":"USD","rateType":"ONGOING"}]}]}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://agencyapi.afterpay.com/v1/rates-contract/123457838/review"

	payload := strings.NewReader("{\n  \"contractId\": \"785389121238\",\n  \"userDetails\": {\n    \"firstName\": \"John\",\n    \"lastName\": \"PSP\",\n    \"email\": \"john.psp@psp.com\"\n  },\n  \"comment\": \"Approved by X on date Y for reason Z.\",\n  \"status\": \"APPROVED\",\n  \"countryCode\": \"US\",\n  \"buyRates\": {\n    \"defaultRates\": {\n      \"variableRatePercentage\": \"5.00\",\n      \"fixedRate\": \"0.30\",\n      \"fixedRateCurrencyCode\": \"USD\",\n      \"rateType\": \"ONGOING\"\n    },\n    \"tierDetails\": [\n      {\n        \"tier\": 1,\n        \"minimumGmv\": \"0\",\n        \"maximumGmv\": \"1000000\",\n        \"GmvCurrencyCode\": \"USD\",\n        \"tieredRates\": [\n          {\n            \"variableRatePercentage\": \"3.5\",\n            \"fixedRate\": \"0.3\",\n            \"fixedRateCurrencyCode\": \"USD\",\n            \"rateType\": \"ONGOING\"\n          }\n        ]\n      }\n    ]\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Accept", "application/json")
	req.Header.Add("User-Agent", "User-Agent")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://agencyapi.afterpay.com/v1/rates-contract/123457838/review")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Accept"] = 'application/json'
request["User-Agent"] = 'User-Agent'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"contractId\": \"785389121238\",\n  \"userDetails\": {\n    \"firstName\": \"John\",\n    \"lastName\": \"PSP\",\n    \"email\": \"john.psp@psp.com\"\n  },\n  \"comment\": \"Approved by X on date Y for reason Z.\",\n  \"status\": \"APPROVED\",\n  \"countryCode\": \"US\",\n  \"buyRates\": {\n    \"defaultRates\": {\n      \"variableRatePercentage\": \"5.00\",\n      \"fixedRate\": \"0.30\",\n      \"fixedRateCurrencyCode\": \"USD\",\n      \"rateType\": \"ONGOING\"\n    },\n    \"tierDetails\": [\n      {\n        \"tier\": 1,\n        \"minimumGmv\": \"0\",\n        \"maximumGmv\": \"1000000\",\n        \"GmvCurrencyCode\": \"USD\",\n        \"tieredRates\": [\n          {\n            \"variableRatePercentage\": \"3.5\",\n            \"fixedRate\": \"0.3\",\n            \"fixedRateCurrencyCode\": \"USD\",\n            \"rateType\": \"ONGOING\"\n          }\n        ]\n      }\n    ]\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://agencyapi.afterpay.com/v1/rates-contract/123457838/review")
  .header("Accept", "application/json")
  .header("User-Agent", "User-Agent")
  .header("Content-Type", "application/json")
  .body("{\n  \"contractId\": \"785389121238\",\n  \"userDetails\": {\n    \"firstName\": \"John\",\n    \"lastName\": \"PSP\",\n    \"email\": \"john.psp@psp.com\"\n  },\n  \"comment\": \"Approved by X on date Y for reason Z.\",\n  \"status\": \"APPROVED\",\n  \"countryCode\": \"US\",\n  \"buyRates\": {\n    \"defaultRates\": {\n      \"variableRatePercentage\": \"5.00\",\n      \"fixedRate\": \"0.30\",\n      \"fixedRateCurrencyCode\": \"USD\",\n      \"rateType\": \"ONGOING\"\n    },\n    \"tierDetails\": [\n      {\n        \"tier\": 1,\n        \"minimumGmv\": \"0\",\n        \"maximumGmv\": \"1000000\",\n        \"GmvCurrencyCode\": \"USD\",\n        \"tieredRates\": [\n          {\n            \"variableRatePercentage\": \"3.5\",\n            \"fixedRate\": \"0.3\",\n            \"fixedRateCurrencyCode\": \"USD\",\n            \"rateType\": \"ONGOING\"\n          }\n        ]\n      }\n    ]\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://agencyapi.afterpay.com/v1/rates-contract/123457838/review', [
  'body' => '{
  "contractId": "785389121238",
  "userDetails": {
    "firstName": "John",
    "lastName": "PSP",
    "email": "john.psp@psp.com"
  },
  "comment": "Approved by X on date Y for reason Z.",
  "status": "APPROVED",
  "countryCode": "US",
  "buyRates": {
    "defaultRates": {
      "variableRatePercentage": "5.00",
      "fixedRate": "0.30",
      "fixedRateCurrencyCode": "USD",
      "rateType": "ONGOING"
    },
    "tierDetails": [
      {
        "tier": 1,
        "minimumGmv": "0",
        "maximumGmv": "1000000",
        "GmvCurrencyCode": "USD",
        "tieredRates": [
          {
            "variableRatePercentage": "3.5",
            "fixedRate": "0.3",
            "fixedRateCurrencyCode": "USD",
            "rateType": "ONGOING"
          }
        ]
      }
    ]
  }
}',
  'headers' => [
    'Accept' => 'application/json',
    'Content-Type' => 'application/json',
    'User-Agent' => 'User-Agent',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://agencyapi.afterpay.com/v1/rates-contract/123457838/review");
var request = new RestRequest(Method.POST);
request.AddHeader("Accept", "application/json");
request.AddHeader("User-Agent", "User-Agent");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"contractId\": \"785389121238\",\n  \"userDetails\": {\n    \"firstName\": \"John\",\n    \"lastName\": \"PSP\",\n    \"email\": \"john.psp@psp.com\"\n  },\n  \"comment\": \"Approved by X on date Y for reason Z.\",\n  \"status\": \"APPROVED\",\n  \"countryCode\": \"US\",\n  \"buyRates\": {\n    \"defaultRates\": {\n      \"variableRatePercentage\": \"5.00\",\n      \"fixedRate\": \"0.30\",\n      \"fixedRateCurrencyCode\": \"USD\",\n      \"rateType\": \"ONGOING\"\n    },\n    \"tierDetails\": [\n      {\n        \"tier\": 1,\n        \"minimumGmv\": \"0\",\n        \"maximumGmv\": \"1000000\",\n        \"GmvCurrencyCode\": \"USD\",\n        \"tieredRates\": [\n          {\n            \"variableRatePercentage\": \"3.5\",\n            \"fixedRate\": \"0.3\",\n            \"fixedRateCurrencyCode\": \"USD\",\n            \"rateType\": \"ONGOING\"\n          }\n        ]\n      }\n    ]\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Accept": "application/json",
  "User-Agent": "User-Agent",
  "Content-Type": "application/json"
]
let parameters = [
  "contractId": "785389121238",
  "userDetails": [
    "firstName": "John",
    "lastName": "PSP",
    "email": "john.psp@psp.com"
  ],
  "comment": "Approved by X on date Y for reason Z.",
  "status": "APPROVED",
  "countryCode": "US",
  "buyRates": [
    "defaultRates": [
      "variableRatePercentage": "5.00",
      "fixedRate": "0.30",
      "fixedRateCurrencyCode": "USD",
      "rateType": "ONGOING"
    ],
    "tierDetails": [
      [
        "tier": 1,
        "minimumGmv": "0",
        "maximumGmv": "1000000",
        "GmvCurrencyCode": "USD",
        "tieredRates": [
          [
            "variableRatePercentage": "3.5",
            "fixedRate": "0.3",
            "fixedRateCurrencyCode": "USD",
            "rateType": "ONGOING"
          ]
        ]
      ]
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://agencyapi.afterpay.com/v1/rates-contract/123457838/review")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```